# -*- coding: utf-8 -*-

# data.py
# This file is part of Qarte
#    
# Author : Vincent Vande Vyvre <vincent.vandevyvre@oqapy.eu>
# Copyright: 2011-2015 Vincent Vande Vyvre
# Licence: GPL3
# Home page : https://launchpad.net/qarte
#
# Constants list, XXX don't forget update VERSION & VERSION_STR if needed.

__all__ = ("VERSION", "VERSION_STR", "DEFAULT_PREFS", "FR_CATEGORIES", 
            "DE_CATEGORIES", "CATEGORIES", "URLS_FR", "URLS_DE", 
            "EXT_CATEGORIES", "PARTNERS", "FESTIVALS", "GROUP_CATEGORIES", 
            "ICONS")

VERSION = (2, 6, 0)

VERSION_STR = "2.6.0"

DEFAULT_PREFS = {'version': VERSION,
                'lang': 'fr',
                'load_pages': (True, False, False),
                'plus_folder': 'None', 
                'live_folder': 'None', 
                'pitch_plus': True,
                'pitch_plus_unique': 1, 
                'pitch_plus_format': 'txt',
                'pitch_live': True,
                'pitch_live_unique': 1, 
                'pitch_live_format': 'html',
                'copythumb_plus': False,
                'copythumb_live': False,
                'update': True, 
                'thumb1': 160, 
                'thumb2': 80, 
                'notify': True,  
                'size': (900, 700),
                'cur_cat': 'Jazz & Blues', 
                'mini': 220, 
                'maxi': 325, 
                'news': [False, True, True, False, True],
                'mailbox': '/var/mail/',
                'crontab_cmd': 'export DISPLAY=:0 & LC_CTYPE="<lang>" Lang="<lang>" python <root> -a <ID>'}

FR_CATEGORIES = [u'Classique', u'Jazz & Blues', u'Pop rock & Electro',
                    u'Théâtre & Danse', u'Musiques du monde', u'Tracks',
                    u'La Blogothèque']

DE_CATEGORIES = [u'Klassik', u'Jazz & Blues', u'Pop, Rock, Electro',
                    u'Theater & Tanz', u'World Music', u'Tracks',
                    u'La Blogothèque']

CATEGORIES = {'fr': {u'Classique': 'Classique',
                    u'Jazz & Blues': 'Jazz___Blues',
                    u'Pop rock & Electro': 'Pop_rock___Electro',
                    u'Théâtre & Danse': 'Theatre___Danse',
                    u'Musiques du monde': 'Musiques_du_monde',
                    u'Tracks': 'tracks',
                    u'La Blogothèque': 'blogo',
                    u'News': 'News'},
            'de': {u'Klassik': 'Klassik_',
                    u'Jazz & Blues': 'Jazz__Blues',
                    u'Pop, Rock, Electro': 'Pop__Rock__Electro',
                    u'Theater & Tanz': 'Theater___Tanz_',
                    u'World Music': 'World_Music',
                    u'Tracks': 'tracks',
                    u'La Blogothèque': 'blogo',
                    u'News': 'News'}}

URLS_FR = {u'Classique': ['http://download.liveweb.arte.tv/o21/liveweb/rss/home-4-fr.rss', 
                          'http://concert.arte.tv/fr/videos/musique-classique'],
            u'Jazz & Blues': ['http://download.liveweb.arte.tv/o21/liveweb/rss/home-34-fr.rss',
                              'http://download.liveweb.arte.tv/o21/liveweb/rss/partner-229-fr.rss', 
                              'http://concert.arte.tv/fr/videos/jazz'],
            u'Pop rock & Electro': ['http://download.liveweb.arte.tv/o21/liveweb/rss/home-25-fr.rss', 
                                    'http://concert.arte.tv/fr/videos/rockpop'],
            u'Théâtre & Danse': ['http://download.liveweb.arte.tv/o21/liveweb/rss/home-10-fr.rss',  
                                 'http://concert.arte.tv/fr/videos/danse'],
            u'Musiques du monde': ['http://download.liveweb.arte.tv/o21/liveweb/rss/home-22-fr.rss',
                                   'http://download.liveweb.arte.tv/o21/liveweb/rss/partner-6-fr.rss', 
                                   'http://concert.arte.tv/fr/videos/musique-du-monde'],
            u'Tracks': ['http://download.liveweb.arte.tv/o21/liveweb/rss/partner-291-fr.rss'],
            u'La Blogothèque': ['http://download.liveweb.arte.tv/o21/liveweb/rss/partner-13-fr.rss']}

URLS_DE = {u'Klassik': ['http://download.liveweb.arte.tv/o21/liveweb/rss/home-5-de.rss',
                          'http://concert.arte.tv/de/videos/klassik'],
            u'Jazz & Blues': ['http://download.liveweb.arte.tv/o21/liveweb/rss/home-35-de.rss',
            'http://download.liveweb.arte.tv/o21/liveweb/rss/partner-229-de.rss',
                              'http://concert.arte.tv/de/videos/jazz'],
            u'Pop, Rock, Electro': ['http://download.liveweb.arte.tv/o21/liveweb/rss/home-26-de.rss',
                                    'http://concert.arte.tv/de/videos/rockpop'],
            u'Theater & Tanz': ['http://download.liveweb.arte.tv/o21/liveweb/rss/home-11-de.rss',
                                 'http://concert.arte.tv/de/videos/tanz'],
            u'World Music': ['http://download.liveweb.arte.tv/o21/liveweb/rss/home-23-de.rss',
                             'http://download.liveweb.arte.tv/o21/liveweb/rss/partner-6-de.rss',
                                   'http://concert.arte.tv/de/videos/worldmusic'],
            u'Tracks': ['http://download.liveweb.arte.tv/o21/liveweb/rss/partner-291-de.rss'],
            u'La Blogothèque': ['http://download.liveweb.arte.tv/o21/liveweb/rss/partner-13-de.rss']}

PARTNERS = {'introd': 'http://download.liveweb.arte.tv/o21/liveweb/rss/partner-621-§.rss',
            'rdr': 'http://download.liveweb.arte.tv/o21/liveweb/rss/partner-268-§.rss',
            'oprf': 'http://download.liveweb.arte.tv/o21/liveweb/rss/partner-5-§.rss',
            'odp': 'http://download.liveweb.arte.tv/o21/liveweb/rss/partner-201-§.rss',
            'cdm': 'http://download.liveweb.arte.tv/o21/liveweb/rss/partner-8-§.rss',
            'lounge': 'http://download.liveweb.arte.tv/o21/liveweb/rss/partner-267-§.rss',
            'hr2': 'http://download.liveweb.arte.tv/o21/liveweb/rss/partner-321-§.rss',
            'mouv': 'http://download.liveweb.arte.tv/o21/liveweb/rss/partner-612-§.rss',
            'pleyel': 'http://download.liveweb.arte.tv/o21/liveweb/rss/partner-42-§.rss',
            'gaite': 'http://download.liveweb.arte.tv/o21/liveweb/rss/partner-338-§.rss',
            'armel': 'http://download.liveweb.arte.tv/o21/liveweb/rss/partner-324-§.rss',
            'branly': 'http://download.liveweb.arte.tv/o21/liveweb/rss/partner-157-§.rss',
            'noisey': 'http://download.liveweb.arte.tv/o21/liveweb/rss/partner-608-§.rss',
            'trans': 'http://download.liveweb.arte.tv/o21/liveweb/rss/partner-212-§.rss',
            'hell': 'http://download.liveweb.arte.tv/o21/liveweb/rss/partner-542-§.rss',
            'nantes': 'http://download.liveweb.arte.tv/o21/liveweb/rss/partner-231-§.rss',
            'africa': 'http://download.liveweb.arte.tv/o21/liveweb/rss/partner-285-§.rss',
            'roque': 'http://download.liveweb.arte.tv/o21/liveweb/rss/partner-313-§.rss',
            'suds': 'http://download.liveweb.arte.tv/o21/liveweb/rss/partner-103-§.rss',
            'aix': 'http://download.liveweb.arte.tv/o21/liveweb/rss/partner-31-§.rss',
            'charrues': 'http://download.liveweb.arte.tv/o21/liveweb/rss/partner-307-§.rss',
            'locos': 'http://download.liveweb.arte.tv/o21/liveweb/rss/partner-289-§.rss',
            'denis': 'http://download.liveweb.arte.tv/o21/liveweb/rss/partner-541-§.rss',
            'nuitsud': 'http://download.liveweb.arte.tv/o21/liveweb/rss/partner-607-§.rss',
            'mahler': 'http://download.liveweb.arte.tv/o21/liveweb/rss/partner-343-§.rss',
            'europa': 'http://download.liveweb.arte.tv/o21/liveweb/rss/partner-508-§.rss',
            'villette': 'http://download.liveweb.arte.tv/o21/liveweb/rss/partner-155-§.rss',
            'dour': 'http://download.liveweb.arte.tv/o21/liveweb/rss/partner-636-§.rss',
            'filvoix': 'http://download.liveweb.arte.tv/o21/liveweb/rss/partner-264-§.rss'}

EXT_CATEGORIES = {'fr': {u'Introducing': 'introd',
                        u'La Route du Rock': 'rdr',
                        u'Orchestre Philarmonique de Radio France': 'oprf',
                        u'Orchestre de Paris': 'odp',
                        u'Cité de la Musique': 'cdm',
                        u'Arte Lounge': 'lounge'},
                'de': {u'Introducing': 'introd',
                        u'La Route du Rock': 'rdr',
                        u'Orchestre Philarmonique de Radio France': 'oprf',
                        u'Orchestre de Paris': 'odp',
                        u'Cité de la Musique': 'cdm',
                        u'Arte Lounge': 'lounge'}}

HALLS = {'fr': {u'HR2Kultur': 'hr2',
                            u"Le Mouv'": 'mouv',
                            u'La salle Pleyel': 'pleyel',
                            u'La gaîté Lyrique': 'gaite',
                            u'Armel Opera': 'armel',
                            u'Musée du Quai Branly': 'branly',
                            u'Noisey': 'noisey'},
                    'de': {u'HR2Kultur': 'hr2',
                            u"Le Mouv'": 'mouv',
                            u'La salle Pleyel': 'pleyel',
                            u'La gaîté Lyrique': 'gaite',
                            u'Armel Opera': 'armel',
                            u'Musée du Quai Branly': 'branly',
                            u'Noisey': 'noisey'}}

FESTIVALS = {'fr': {u'Les Trans Musicales de Rennes': 'trans',
                    u'Hellfest': 'hell',
                    u'La Folle Journée de Nantes': 'nantes',
                    u'Africa Festival': 'africa',
                    u"La Roque d'Anthéron": 'roque',
                    u'Les Suds à Arles': 'suds',
                    u"Festival d'Aix-en-Provence": 'aix',
                    u'Les Vielles Charrues': 'charrues',
                    u'Rio Locos': 'locos',
                    u'Festival de Saint Denis': 'denis',
                    u'Les nuits du Sud': 'nuitsud',
                    u'Mahler Festival': 'mahler',
                    u'Europavox': 'europa',
                    u'Jazz à la Vilette': 'villette',
                    u'Dour': 'dour',
                    u'Au Fil des Voix': 'filvoix'},
            'de': {u'Les Trans Musicales de Rennes': 'trans',
                    u'Hellfest': 'hell',
                    u'La Folle Journée de Nantes': 'nantes',
                    u'Africa Festival': 'africa',
                    u"La Roque d'Anthéron": 'roque',
                    u'Les Suds à Arles': 'suds',
                    u"Festival d'Aix-en-Provence": 'aix',
                    u'Les Vielles Charrues': 'charrues',
                    u'Rio Locos': 'locos',
                    u'Festival de Saint Denis': 'denis',
                    u'Les nuits du Sud': 'nuitsud',
                    u'Mahler Festival': 'mahler',
                    u'Europavox': 'europa',
                    u'Jazz à la Vilette': 'villette',
                    u'Dour': 'dour',
                    u'Au Fil des Voix': 'filvoix'}}

ICONS = {'plus': {},
        'live': {'clson': 'medias/classic_on.png',
                'clsoff': 'medias/classic_off.png',
                'jazon': 'medias/jazz_on.png',
                'jazoff': 'medias/jazz_off.png',
                'rockon': 'medias/rock_on.png',
                'rockoff': 'medias/rock_off.png',
                'thton': 'medias/theater_on.png',
                'thtoff': 'medias/theater_off.png',
                'wrlon': 'medias/world_on.png',
                'wrloff': 'medias/world_off.png',
                'nwon': 'medias/news_on.png',
                'nwoff': 'medias/news_off.png',
                'blogon': 'medias/blogo_on.png',
                'blogoff': 'medias/blogo_off.png',
                'trkon': 'medias/tracks_on.png',
                'trkoff': 'medias/tracks_off.png',
                'blgon': 'medias/blogo_on.png',
                'blgoff': 'medias/blogo_off.png',
                'introdon': 'medias/introd_on.png',
                'introdoff': 'medias/introd_off.png',
                'rdron': 'medias/rdr_on.png',
                'rdroff': 'medias/rdr_off.png',
                'oprfon': 'medias/oprf_on.png',
                'oprfoff': 'medias/oprf_off.png',
                'odpon': 'medias/odp_on.png',
                'odpoff': 'medias/odp_off.png',
                'cdmon': 'medias/cdm_on.png',
                'cdmoff': 'medias/cdm_off.png',
                'lngon': 'medias/lounge_on.png',
                'lngoff': 'medias/lounge_off.png'}}
